> For the complete documentation index, see [llms.txt](https://developer.9bits.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.9bits.net/messaging/two-way-sms/rest-api/webhooks.md).

# Webhooks

A callback is an HTTP POST request with a notification made by 9bits REST API to a URI of your choosing.

The REST API expects the receiving server to respond with a response code within the `2xx` success range. For `5xx` the callback will be retried. For `429` the callback will be retried and the throughput will be lowered. For other status codes in the `4xx` range the callback will not be retried. The first initial retry will happen 30 seconds after the first try. The next attempt is after 60 seconds, then after 120 seconds. The last retry will be 3600 seconds after the initial failed attempt.

The SMS REST API offers the following callback options which can be configured for your account upon request to your account manager.

* Callback with no authentication.
* Callback with basic authentication by provisioning the callback URL with username and password..


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.9bits.net/messaging/two-way-sms/rest-api/webhooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
